# the application starts here

proc getUptime {} {
  set iTime [expr [clock seconds]-$::iStartTime]
}

proc doLogin { sUser sPass } {
  if { $sUser == "test" && $sPass == "demo" } {
    return 1
  } else {
    return 0
  }
}

set iStartTime [clock seconds]

pack [label .title -text "mkHttpd Demo Application" -font {courier 14 bold} -bg #088 -fg white -anchor w -padx 5 -pady 5] -fill x
pack [frame .hsep1 -border 1 -relief sunken -height 2] -pady 5 -fill x
pack [label .howto -text "Start up a web browser and enter the URL http://localhost:1080"] -anchor w
pack [frame .hsep2 -border 1 -relief sunken -height 2] -pady 5 -fill x
pack [label .label -text "Enter some text in the entry field below:"] -anchor w
pack [entry .entry -textvariable sText] -fill x

# this is the end of the application code. the following implements
# the interface from the web pages to the application.

package require mkHttpd

class Test:Session { args } {
  eval [this] Session:+ $args
} {
  [this] Session:-
}

member Test:getUptimeString {} {
  set iUp [getUptime]
  set sString [format "%d minutes and %d seconds" [expr $iUp/60] [expr $iUp%60]]
  return $sString
}

member Test:getText {} {
  return $::sText
}

member Test:checkLogin { sUser sPass } {
  return [doLogin $sUser $sPass]
}

member Test:fakeData {} {
  set sText "This text comes from inside the Session object!"
  [this] replyData text/plain $sText
}

Httpd www -port 1080 -name Demo -session Test -default demo.html

